

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float u_ctime;
uniform float u_threshold;
uniform float u_radius;
uniform vec4  u_outlineColor;

void main() {
    float radius = u_radius;
    
    vec4 accum  = vec4(0.0);
    vec4 normal = vec4(0.0);
    
    normal = texture2D(CC_Texture0, v_texCoord);
    
    for(float i = 1.0; i <= radius; i += 1.0) {
        accum += texture2D(CC_Texture0, vec2(v_texCoord.x - 0.01 * i, v_texCoord.y - 0.01 * i));
        accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.01 * i, v_texCoord.y - 0.01 * i));
        accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.01 * i, v_texCoord.y + 0.01 * i));
        accum += texture2D(CC_Texture0, vec2(v_texCoord.x - 0.01 * i, v_texCoord.y + 0.01 * i));
    }
    
    accum.rgb =  u_outlineColor.rgb * u_outlineColor.a * accum.a * 0.95;
    float opacity = ((1.0 - normal.a) / radius) * (u_ctime / u_threshold);
    
    normal = (accum * opacity) + (normal * normal.a);
    
    gl_FragColor = v_fragmentColor * normal;
}


/*
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float u_ctime;

#define M_PI 3.1415926535897932384626433832795

void main() {
    vec2 coord = v_texCoord;
    coord.x += (sin(coord.y * 10.0 + u_ctime * 10.0) / 30.0);
    gl_FragColor = texture2D(CC_Texture0, coord);
}
*/
/*
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float u_wind;

float easeInCubic(float t, float b, float c, float d) {
    t /= d;
    return c*t*t*t + b;
}

void main() {
    vec2 coord = v_texCoord;
    float wind = u_wind - 0.5;
    coord.x += wind * easeInCubic(1.0 - coord.y, 0.0, 1.0, 1.0);
    vec4 tex = texture2D(CC_Texture0, coord);
    gl_FragColor = tex * v_fragmentColor;
}
*/